﻿/*
 * * * Compile_AHK SETTINGS BEGIN * * *

[AHK2EXE]
Exe_File=%In_Dir%\Witopia PPTP connect.exe
No_UPX=1
[ICONS]
Icon_1=%In_Dir%\Icon_Set3\locked.ico

* * * Compile_AHK SETTINGS END * * *
*/

#SingleInstance force
#Persistent
#NoEnv
SetWorkingDir %A_ScriptDir%
Splitpath, A_ScriptFullPath,,,,title

Temp = %A_Temp%\%Title%

Gosub,ReadIni
Gosub,InstallFiles
Gosub,StartupRoutines
Gosub,CreateTrayMenu
Gosub,CheckConnectionStatus



Return



FillPPTPMenu:
region = AFRICA MIDDLE EAST|Asia|Canada|CENTRAL SOUTH|Europe|Oceania|USA
stringsplit,regionSplit,region,|
loop,%regionSplit0%
{
	region := regionSplit%a_index%
	
	FileRead,ServerListT,Support files\PPTP VPN %region%.txt
	If Serverlist = 
		Serverlist = %ServerListT%
	else
		Serverlist = %Serverlist%`n%ServerListT%
	ServerlistT = 

	If Region = AFRICA MIDDLE EAST
		Menu = Africa/Middle East
	else If Region = CENTRAL SOUTH
		Menu = Central/South America
	else Menu := Region

	Loop
	{
		FileReadLine, Line, Support files\PPTP VPN %region%.txt, %A_Index%
		If Errorlevel
			Break
		Line = %Line%  
		If Line = 
			Break
		StringSplit, PPTPentry, Line,(,)
		PPTPentry2 = %PPTPentry2%
		Menu,%menu%,Add,%PPTPentry2%,VPNCONNECT
	}
	Menu,ConnectionList,Add,%Menu%,:%menu%

}
Menu,tray,Add,Connect to,:ConnectionList
Return




FillPPTPMenuFavorites:
Menu,Tray,Add
FavCount = 0
Loop,99
{
	IniRead,Favorite,%title%.ini,Favorites,%a_index%,%a_space%
	favorite = %favorite%
	If Favorite = 
		Continue
	If Serverlist not contains %Favorite%
		Continue
	Menu,Tray,add,%Favorite%,VPNCONNECT
;	Menu,Favorites,add,%Favorite%,VPNCONNECT
	FavCount := FavCount +1
}
If FavCount <> 0
{
;	Menu,tray,Add,Favorites,:Favorites
	Menu,Tray,Add
}
Return


;;; VPN Connect - Starting
VPNCONNECT:
Retry = 0
Retrytxt = 
Serverlist = %Serverlist%
Loop, parse, Serverlist, `n, `r
{
	StringSplit, PPTPentry, A_LoopField,(,)
	If PPTPentry2 = %A_ThisMenuItem%
	{
		IfNotExist,%Temp%\Checking.ico
			Gosub,InstallFiles
		Menu,Tray,Icon,%Temp%\Checking.ico

		ConnectedTo = %PPTPentry2%

		;;; VPN Connect- Getting IP (rasdial can't resolve DNS)
		RunWait,%comspec% /c "ping -a %PPTPentry1% -n 1 -w 1 >"%Temp%\rasdial_output.txt"",USERRORLEVEL,hide	
		FileRead,Dummy,%Temp%\rasdial_output.txt
		StringGetPos, DummyS, Dummy, [ 
		StringGetPos, DummyE, Dummy, ]
		DummyS := DummyS +2
		DummyE := (DummyE+1)-DummyS
		StringMid, IP, Dummy, %DummyS%, %DummyE%
		IfNotExist,%Temp%\Witopia.pbk
			Gosub,InstallFiles
		IniWrite, %IP%, %Temp%\Witopia.pbk, Witopia, PhoneNumber

		RetryVPN:
		;;; VPN Connect - Disconnecting and connecting
		IfNotExist,%Temp%\Checking.ico
			Gosub,InstallFiles
		Menu,Tray,Icon,%Temp%\Checking.ico
		If Retry <> 0
			Retrytxt = `nRetry %Retry% because of error %Error%!
		Menu,Tray,Tip, Connecting to %PPTPentry1% (%IP%)... %Retrytxt%
		Retry := Retry + 1
		random,zufall
		FileCopy,%Temp%\Witopia.pbk,%Temp%\Witopia_%Zufall%.pbk,1
		RunWait,%comspec% /c "rasdial /disconnect",,hide
		RunWait,%comspec% /c "rasdial Witopia %Username% %Password% /PHONEBOOK:"%Temp%\Witopia_%Zufall%.pbk" >"%Temp%\rasdial_output.txt"",UseErrorLevel,hide
		Error := errorlevel
		FileDelete,%Temp%\Witopia_%Zufall%.pbk

		if Error <> 0
		{
			if Retry > %ConnectionTries%
			{
				LastCMD = rasdial Witopia %Username% %Password% /PHONEBOOK:%Temp%\Witopia.pbk
				FileRead,rasdialerror,%Temp%\rasdial_output.txt
				OnMessage(0x44, "CONNMESSAGE")
				Msgbox,1,%Title% - RASDial reported an error,RASDIAL reported errorcode %error%.Here's the command I sent to RASDIAL:`n"%lastcmd%"`n`nHere's the error message I received:`n`n%RASDIALERROR%
				OnMessage(0x44, "")
				IfMsgbox,Cancel
					ExitApp
			}
			else
			{
				IfNotExist,%Temp%\Unlocked.ico
					Gosub,InstallFiles
				Menu,Tray,Icon,%Temp%\Unlocked.ico
				Sleep,500
				Goto,RetryVPN
			}
		}
		else
		{

			If TrayTips = 1
			{
				IfNotExist,%Temp%\locked.ico
					Gosub,InstallFiles
				Menu,Tray,Icon,%Temp%\locked.ico
				TrayTip,, Connected with "%PPTPentry2%"..., 30, 1
				Sleep,5000
				TrayTip
			}
		}
		Gosub,CheckConnectionStatus
		Break
	}
}
Return




;;; Check Connection status - Works only with PPPT connections which name contains Witopia
CheckConnectionStatus:
FileDelete,%Temp%\rasdial_output.txt
RunWait,%comspec% /c "rasdial >"%Temp%\rasdial_output.txt"",USERRORLEVEL,hide
FileRead,Dummy,%Temp%\rasdial_output.txt
If Dummy Contains Witopia
{
	If ConnectedTo = 
		ConnectedTo = Witopia PPTP 
	MenuPPTPNameO = %MenuPPTPName%
	MenuPPTPName = Connected with: `n%ConnectedTo%
	Menu,Tray,Tip, %MenuPPTPName%
	If MenuPPTPNameO <> %MenuPPTPName%
		Menu,Tray,Rename,%MenuPPTPNameO%,%MenuPPTPName%
	IfNotExist,%Temp%\Locked.ico
		Gosub,InstallFiles
	Menu,Tray,Icon,%Temp%\Locked.ico
	If Conn_Loss = 1
		SetTimer,ConnLoss,On

}
else
{
	MenuPPTPNameO = %MenuPPTPName%
	MenuPPTPName = No Witopia PPTP connection active
	Menu,Tray,Tip, No PPTP connection
	If MenuPPTPNameO <> %MenuPPTPName%
		Menu,Tray,Rename,%MenuPPTPNameO%,%MenuPPTPName%
	IfNotExist,%Temp%\Unlocked.ico
		Gosub,InstallFiles
	Menu,Tray,Icon,%Temp%\Unlocked.ico
	If Conn_Loss = 1
		SetTimer,ConnLoss,Off
}
Return




;;; Script startup routines
StartupRoutines:

IfNotExist,%Temp%\Checking.ico
	Gosub,InstallFiles
Menu,Tray,Icon,%Temp%\Checking.ico

MenuPPTPName = PPTP Status
Menu,Tray,NoStandard
Menu,Tray,Add,Exit Script,Exit		; so the user can exit the script if something fails

SetTimer,ConnLoss,%Conn_Interval%000
SetTimer,ConnLoss,Off			; now it can be enabled with "on"

IfNotExist,%title%.ini
{
	Menu, Tray, DeleteAll
	Menu,Tray,Add,Exit Script,Exit
	msgbox,File "%title%.ini" is missing.`n`nPlease re-download distribution.
	ExitApp
}

region = AFRICA MIDDLE EAST|Asia|Canada|CENTRAL SOUTH|Europe|Oceania|USA
stringsplit,regionSplit,region,|
loop,%regionSplit0%
{
	region := regionSplit%a_index%
	IfNotExist,Support files\PPTP VPN %region%.txt
	{
		msgbox,16,%title% - Warning,File "Support files\PPTP VPN %region%.txt" is missing.`n`nPlease re-download distribution.
		ExitApp
	}
}
	
IfNotExist,%title%.ini
{
	msgbox,16,%title% - Warning,File "Support files\PPTP VPN %region%.txt" is missing.`n`nPlease re-download distribution.
	ExitApp
}

IniRead, SavePassword, %title%.ini, ACCOUNT, SavePassword,%A_Space%
If SavePassword = 
{
	OnMessage(0x44, "INTROMESSAGE")
	msgbox, 67, %title%, This seems to be your first start.`n`nFor new users it's a good idea to read some information about this script. Please click "Read Info". After reading you'll have to start the script again.`n`nClick "Configure" to finish configuration.
	OnMessage(0x44, "")
	IfMsgBox,Yes
	{
		IfNotExist,%title% - Read Me.txt
			msgbox, 16, %title%, Can't find "%title% - Read Me.txt"`n`nPlease look in the script folder for a text file`, or re-download the distribution.
		else
			Run,Notepad %title% - Read Me.txt
		ExitApp
	}
	IfMsgBox,Cancel
		ExitApp
	

	msgbox, 35, %title% - First Start, Should I save (remember) your Witopia password?`n`nNote: It will be written as plain text in a configuration file. `n`nIf this is unacceptable for you`, please click No. You'll be prompted to enter your password each time you start this script.	
	IfMsgBox,Cancel
		ExitApp
	IfMsgBox,No
		SavePassword = 0
	else
		SavePassword = 1
	IniWrite, %SavePassword%, %title%.ini, ACCOUNT, SavePassword
}

IniRead, Username, %title%.ini, ACCOUNT, Username,%A_Space%
if Username =
{
	InputBox,Username,%title% - User name,Your Witopia username (including @witopia)?`n`nExample: myusername@witopia,,350,170
	If Errorlevel = 1
		ExitApp
	If Username = 
		ExitApp
	IniWrite, %Username%, %title%.ini, ACCOUNT, Username
}

IniRead, Password, %title%.ini, ACCOUNT, Password,%A_Space%
if Password =
{
	If SavePassword = 0
		InputBox,Password,%title% - Password,Your Witopia password?,HIDE,300,130
	else
		InputBox,Password,%title% - Password,Your Witopia password?,,300,130
	If Errorlevel = 1
		ExitApp
	If Password = 
		ExitApp

	If SavePassword = 1
		IniWrite, %Password%, %title%.ini, ACCOUNT, Password
	; For those reading the source and thinking "OMG! WTF is he doing?!"
	; Storing the password as plain text is a security risk. 
        ; The user is informed about this fact (first run wizard) and is asked if the script should save it or not. 
}
Return




;;; Manually disconnect
VPNDisconnect:
SetTimer,ConnLoss,Off
if DisconnectPrompt = 1
{
	If ConnectedTo = 
		dummy = Disconnect PPTP connection?
	else
		dummy = Disconnect "%ConnectedTo%"?
	msgbox, 36, %title%,%dummy%
	IfMsgbox,No
	{
		If Conn_Loss = 1
			SetTimer,ConnLoss,On
		Return
	}
}
IfNotExist,%Temp%\Checking.ico
	Gosub,InstallFiles
Menu,Tray,Icon,%Temp%\Checking.ico
RunWait,%comspec% /c "rasdial /disconnect",,hide
Gosub,CheckConnectionStatus
ConnectedTo=
Return




;;; Connection Loss Routine
ConnLoss:
IfNotExist,%Temp%\Checking.ico
	Gosub,InstallFiles
Menu,Tray,Icon,%Temp%\Checking.ico
FileDelete,%Temp%\rasdial_output.txt
RunWait,%comspec% /c "rasdial >"%Temp%\rasdial_output.txt"",USERRORLEVEL,hide
FileRead,Dummy,%Temp%\rasdial_output.txt
If Dummy Contains Witopia
{
	IfNotExist,%Temp%\locked.ico
		Gosub,InstallFiles
	Menu,Tray,Icon,%Temp%\locked.ico
	If Conn_Loss = 1
		SetTimer,ConnLoss,On
	Return
}
If MenuPPTPName = No Witopia PPTP connection active
{
	IfNotExist,%Temp%\unlocked.ico
		Gosub,InstallFiles
	Menu,Tray,Icon,%Temp%\unlocked.ico
	Return
}
SetTimer,ConnLoss,Off
Gosub,CheckConnectionStatus
If Conn_Warning = 1
{
	FormatTime,CurrentTime,,HH:mm:ss
	msgbox, 262192, %title% - Warning!, PPTP connection "%ConnectedTo%" lost ... `n`nPlease check!`n`nTime of this message: %CurrentTime%
}
else
{
	If TrayTips = 1
	{
		TrayTip,, PPTP connection "%ConnectedTo%" lost!, 30, 2
		Sleep,10000
		TrayTip
	}
}
ConnectedTo=
Return




;;; Menu launchers
CheckNow:
Gosub,CheckConnectionStatus
Gosub,ConnLoss
Return

Reload:
Reload
Return

BrowserLocation:
Run,http://en.utrace.de/
Return

MyIP:
Run,http://www.ip-adress.com/what_is_my_ip/
Return

EditINI:
FileToEdit = %title%.ini
Goto,EditApplyChanges

EditServerList:
Run, "Support Files"
Goto,EditApplyChanges

EditApplyChanges:
Run,"%FileToEdit%"
If TrayTips = 1
{
	TrayTip,, Reload this script to apply changes..., 30, 1
	Sleep,3000
	TrayTip
}
Return




;;; Read INI File
ReadIni:
IniRead, StatusSymbol, %title%.ini, SETTINGS, StatusSymbol,%a_space% 
IniRead, TrayTips, %title%.ini, SETTINGS, TrayTips,%a_space%
IniRead, ConnectionTries, %title%.ini, SETTINGS, ConnectionTries,%a_space%
IniRead, DisconnectPrompt, %title%.ini, SETTINGS, DisconnectPrompt,%a_space% 
IniRead, Conn_Loss, %title%.ini, CONNECTION_LOSS_SETTINGS, CHECK_FOR_CONNECTION_LOSS,%a_space%
IniRead, Conn_Interval, %title%.ini, CONNECTION_LOSS_SETTINGS, CHECK_INTERVAL,%a_space%
IniRead, Conn_Warning, %title%.ini, CONNECTION_LOSS_SETTINGS, WARNING_AT_CONNECTION_LOSS,%a_space%

If StatusSymbol = 
	StatussSymbol = 1
If DisconnectPrompt = 
	DisconnectPrompt = 1
If ConnectionTries = 
	ConnectionTries = 3
If TrayTips =
	TrayTips = 1
If Conn_Loss =
	Conn_Loss = 1
If Conn_Interval = 
	Conn_Interval = 30
If Conn_Warning = 
	Conn_Warning = 0
Return




;;; Install icon and phonebook
InstallFiles:
FileCreateDir, %Temp%
FileInstall, Icon_Set3\Unlocked.ico, %Temp%\Unlocked.ico,1
FileInstall, Icon_Set3\Locked.ico, %Temp%\Locked.ico,1
If StatusSymbol = 1
	FileInstall, Icon_Set3\Checking.ico, %Temp%\Checking.ico,1
else
	FileInstall, Icon_Set3\Locked.ico, %Temp%\Checking.ico,1
FileInstall, Witopia.pbk, %Temp%\Witopia.pbk,1
IfNotExist,%temp%\Checking.ico
{
	msgbox,Couldn't write file %temp%\Checking.ico. Abort
	ExitApp
}
Return




;;; Create the Tray menu
CreateTrayMenu:
Menu,Tray,DeleteAll
Menu,Tray,Add,Witopia PPTP Connector,VPNCONNECT
Menu,Tray,Add,%MenuPPTPName%,VPNCONNECT
Menu,Tray,Add,

Menu,Edit configuration,Add,Edit script INI,EditINI
Menu,Edit configuration,Add,
Menu,Edit configuration,Add,Edit Serverlist Files,EditServerList
Menu,Edit configuration,Add,
Menu,Edit configuration,Add,Reload,Reload
Menu,Tray,Add,Edit configuration,:Edit Configuration
Menu,Tray,Add

Menu,Tray,Add,Check Location in browser,BrowserLocation
Menu,Tray,Add,What Is My IP,MyIP
Menu,Tray,Add,
Gosub,FillPPTPMenu
Gosub,FillPPTPMenuFavorites
Menu,Tray,Add,Check now,CheckNow
Menu,Tray,Add,Disconnect,VPNDisconnect
Menu,Tray,Add,
Menu,Tray,Add,Exit Script,Exit

Menu,Tray,Disable,Witopia PPTP Connector
Menu,Tray,Disable,%MenuPPTPName%

Return




;;; Exit script
Exit:
IfNotExist,%Temp%\Checking.ico
	Gosub,InstallFiles
Menu,Tray,Icon,%Temp%\Checking.ico
FileDelete,%Temp%\rasdial_output.txt
RunWait,%comspec% /c "rasdial >"%Temp%\rasdial_output.txt"",USERRORLEVEL,hide
FileRead,Dummy,%Temp%\rasdial_output.txt
If Dummy Contains Witopia
{	
	SetTimer,ConnLoss,Off
	If ConnectedTo = Witopia PPTP
		dummy = Witopia PPTP connection
	else
		dummy = %ConnectedTo%
	OnMessage(0x44, "EXITMESSAGE")
	msgbox, 35, %Title%, You want to exit the script,`nbut you're still connected to "%dummy%".`n`nWhat should I do?
	OnMessage(0x44, "")
	IfMsgBox,Cancel
	{
		Gosub,CheckConnectionStatus
		SetTimer,ConnLoss,On
		Return
	}
	IfMsgbox,Yes
		RunWait,%comspec% /c "rasdial /disconnect",,hide
}
ExitApp


;; Function by Lexikos (AHK forum) 
INTROMESSAGE(wParam) 
{
	if (wParam = 1027)
	{
		Process, Exist
		DetectHiddenWindows, On
		if WinExist(title . " ahk_class #32770 ahk_pid " . ErrorLevel)
		{
			ControlSetText, Button1, &Read Info
			ControlSetText, Button2, C&onfigure
			ControlSetText, Button3, &Cancel
		}
        }    
}
EXITMESSAGE(wParam) 
{
	if (wParam = 1027)
	{
		Process, Exist
		DetectHiddenWindows, On
		if WinExist(title . " ahk_class #32770 ahk_pid " . ErrorLevel)
		{
			ControlSetText, Button1, &Disconnect
			ControlSetText, Button2, &Stay connected
			ControlSetText, Button3, Don't e&xit
		}
        }    
}
CONNMESSAGE(wParam) 
{
	if (wParam = 1027)
	{
		Process, Exist
		DetectHiddenWindows, On
		if WinExist(title . " ahk_class #32770 ahk_pid " . ErrorLevel)
		{
			ControlSetText, Button1, &OK
			ControlSetText, Button2, &Exit script
		}
        }    
}